#if defined _weapon_limit_included
	#endinput
#endif
#define _weapon_limit_included

// БЕЗ weapon_ (deagle, awp, и тд)

enum WL_Event
{
	WL_OnBuyRestrictedWeapon = 0,	// public bool:CallBack(client, const String:weapon[]); - return true = разрешить покупку запрещённого оружия, false = запретить.
	WL_OnPickupRestrictedWeapon,	// public bool:CallBack(client, const String:weapon[]); - return true = разрешить подбор  запрещённого оружия, false = запретить.
	WL_OnWeaponLimited,				// public CallBack(const String:weapon[], limit); - оружие ограничено x на команду (если "all", то всё оружие)
	WL_OnWeaponAllowed				// public CallBack(const String:weapon[]); - оружие разрешено (если "all", то всё оружие)
};

// В csgo WL_OnWeaponLimited и WL_OnWeaponAllowed не покажет "m4a1_silencer", покажет "m4a1" (см. wS_GetMainWeaponName в functions.sp)
// В csgo если const String:weapon[] равен "m4a1", то это значит что оба оружия были ограничены: "m4a1" и "m4a1_silencer".
	
native WL_HookEvent  (WL_Event:event, Function:CallBack);
native WL_UnHookEvent(WL_Event:event, Function:CallBack);

// Если оружие ограничено, вернёт число 0 или выше (x на команду), иначе -1 (не ограничено).
native WL_GetWeaponLimit(const String:weapon[]);

// Cvar wl_pause
// true  = временно позволено использовать всё оружие, при этом все настройки ограничения остаются в силе (в конце карты wl_pause меняется на 0).
// false = ограничение оружия работает как и должно
native bool:WL_Paused();

// Возвращает слот оружия или -1 если ошибка.
// 0 - автомат, дробовик, и тд
// 1 - пистолет
// 2 - нож / taser
// 3 - граната
// 4 - c4
native WL_GetWeaponSlot(const String:weapon[]);

public SharedPlugin:__pl_weapon_limit = 
{
	name = "weapon_limit",
	file = "weapon_limit.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_weapon_limit_SetNTVOptional()
{
	MarkNativeAsOptional("WL_HookEvent");
	MarkNativeAsOptional("WL_UnHookEvent");
	MarkNativeAsOptional("WL_GetWeaponLimit");
	MarkNativeAsOptional("WL_Paused");
	MarkNativeAsOptional("WL_GetWeaponSlot");
}
#endif