static WeaponIndexInAr[MAXPLAYERS + 1];
static LastMenuPos[MAXPLAYERS + 1];
static bool:bFromSMAdminMenu[MAXPLAYERS + 1];

public Action:wl_admin(client, args)
{
	if (client > 0 && client <= MaxClients)
	{
		bFromSMAdminMenu[client] = false;
		wS_ShowAdminMenu(client);
	}
	return Plugin_Handled;
}

static bool:HaveAccessToMenu(client)
	return CheckCommandAccess(client, "wl_admin", WL_FLAG, false);

//
public OnLibraryRemoved(const String:name[]) { if (!strcmp(name, "adminmenu", false)) g_hSMAdminMenu = INVALID_HANDLE; }
public OnAdminMenuReady(Handle:topmenu)
{
	if (topmenu && !g_hSMAdminMenu)
	{
		g_hSMAdminMenu = topmenu;
		decl TopMenuObject:category;
		if ((category = FindTopMenuCategory(g_hSMAdminMenu, ADMINMENU_SERVERCOMMANDS)) != INVALID_TOPMENUOBJECT
			|| (category = FindTopMenuCategory(g_hSMAdminMenu, ADMINMENU_PLAYERCOMMANDS)) != INVALID_TOPMENUOBJECT)
		{
			AddToTopMenu(g_hSMAdminMenu, "wl_admin", TopMenuObject_Item, TopMenu_CallBack, category, "wl_admin", WL_FLAG);
		}
	}
}
public TopMenu_CallBack(Handle:topmenu, TopMenuAction:action, TopMenuObject:object_id, param, String:buffer[], maxlength)
{
	switch (action)
	{
		case TopMenuAction_DisplayOption:
		{
			FormatEx(buffer, maxlength, "%T", "_title", param, GetTrieSize(g_Limit_Trie));
		}
		case TopMenuAction_SelectOption :
		{
			bFromSMAdminMenu[param] = true;
			wS_ShowAdminMenu(param);
		}
	}
}
//

stock wS_ShowAdminMenu(client)
{
	new LimitedWeapons = GetTrieSize(g_Limit_Trie);
	
	new Handle:menu = CreateMenu(AdminMenu_CallBack);
	SetMenuTitle(menu, "%T\n \n", "_title", client, LimitedWeapons);
	if (bFromSMAdminMenu[client]) SetMenuExitBackButton(menu, true);
	decl String:sText[64];
	
	FormatEx(sText, sizeof(sText), "%T", "_restrict"		, client);
	AddMenuItem(menu, "_restrict"		, sText, ITEMDRAW_DEFAULT);
	
	FormatEx(sText, sizeof(sText), "%T", "_unrestrict"		, client);
	AddMenuItem(menu, "_unrestrict"		, sText, LimitedWeapons ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);
	
	FormatEx(sText, sizeof(sText), "%T", "_restrict all"	, client);
	AddMenuItem(menu, "_restrict all"	, sText, ITEMDRAW_DEFAULT);
	
	FormatEx(sText, sizeof(sText), "%T", "_unrestrict all"	, client);
	AddMenuItem(menu, "_unrestrict all"	, sText, LimitedWeapons ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);
	
	DisplayMenu(menu, client, 0);
}

public AdminMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && g_hSMAdminMenu)
		DisplayTopMenu(g_hSMAdminMenu, client, TopMenuPosition_LastCategory);
	
	else if (action == MenuAction_Select && HaveAccessToMenu(client))
	{
		decl String:s[32];
		if (!GetMenuItem(menu, item, s, sizeof(s)))
			return;
		
		if (!strcmp(s, "_restrict"))
		{
			g_Action[client] = wl_Restrict;
			LastMenuPos[client] = 0;
			wS_ShowRestrictMenu(client);
		}
		
		else if (!strcmp(s, "_unrestrict"))
		{
			g_Action[client] = wl_UnRestrict;
			LastMenuPos[client] = 0;
			wS_ShowUnRestrictMenu(client);
		}
		
		else if (!strcmp(s, "_restrict all"))
		{
			g_Action[client] = wl_RestrictAll;
			FakeClientCommand(client, "wl_restrict_all");
			CreateTimer(FSEC, _restrict_TIMER, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
		}
		
		else if (!strcmp(s, "_unrestrict all"))
		{
			g_Action[client] = wl_UnRestrictAll;
			FakeClientCommand(client, "wl_unrestrict_all");
			CreateTimer(FSEC, _restrict_TIMER, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

stock wS_ShowRestrictMenu(client)
{
	new Handle:menu = CreateMenu(_restrict_CallBack);
	SetMenuTitle(menu, "%T\n \n", "_restrict", client);
	SetMenuExitBackButton(menu, true);
	
	decl String:weapon_[WEAPON_LENGTH], String:sIndex[8], String:s[64], limit;
	new count = GetArraySize(g_Items_Arrr);
	
	for (new index = 0; index < count; index++)
	{
		GetArrayString(g_Items_Arrr, index, weapon_, WEAPON_LENGTH);
		if (strcmp(weapon_, NEW_LINE_SYMBOL) != 0)
		{
			IntToString(index, sIndex, sizeof(sIndex));
			if (GetTrieValue(g_Limit_Trie, weapon_, limit))
			{
				FormatEx(s, sizeof(s), "%s [%d]", weapon_, limit);
				AddMenuItem(menu, sIndex, s, ITEMDRAW_DEFAULT);
			}
			else
				AddMenuItem(menu, sIndex, weapon_, ITEMDRAW_DEFAULT);
		}
	}
	
	DisplayMenuAtItem(menu, client, LastMenuPos[client], 0);
}

stock wS_ShowUnRestrictMenu(client)
{
	if (GetTrieSize(g_Limit_Trie) < 1)
	{
		wS_ShowAdminMenu(client);
		return;
	}
	
	new Handle:menu = CreateMenu(_restrict_CallBack);
	SetMenuTitle(menu, "%T\n \n", "_unrestrict", client);
	SetMenuExitBackButton(menu, true);
	
	decl String:weapon_[WEAPON_LENGTH], String:sIndex[8], String:s[64], limit;
	new count = GetArraySize(g_Items_Arrr);
	s[0] = 0;
	
	for (new index = 0; index < count; index++)
	{
		GetArrayString(g_Items_Arrr, index, weapon_, WEAPON_LENGTH);
		if (GetTrieValue(g_Limit_Trie, weapon_, limit))
		{
			IntToString(index, sIndex, sizeof(sIndex));
			FormatEx(s, sizeof(s), "%s [%d]", weapon_, limit);
			AddMenuItem(menu, sIndex, s, ITEMDRAW_DEFAULT);
		}
	}
	
	if (!s[0]) AddMenuItem(menu, "", "._.", ITEMDRAW_DISABLED);
	DisplayMenuAtItem(menu, client, LastMenuPos[client], 0);
}

public _restrict_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && HaveAccessToMenu(client))
		wS_ShowAdminMenu(client);
	
	else if (action == MenuAction_Select && HaveAccessToMenu(client))
	{
		decl String:sIndex[8];
		if (!GetMenuItem(menu, item, sIndex, sizeof(sIndex)))
			return;
		
		LastMenuPos[client] = GetMenuSelectionPosition();
		
		decl String:weapon_[WEAPON_LENGTH];
		GetArrayString(g_Items_Arrr, (WeaponIndexInAr[client] = StringToInt(sIndex)), weapon_, WEAPON_LENGTH);
		
		if (g_Action[client] == wl_Restrict)
		{
			g_Action[client] = wl_RestrictChatWait;
			PrintToChat(client, weapon_);
			PrintToChat(client, "%s\x04%t", g_bCSGO ? " " : "", "_restrict_chat_wait", MaxClients);
		}
		else
		{
			FakeClientCommand(client, "wl_unrestrict %s", weapon_);
			CreateTimer(FSEC, _restrict_TIMER, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

public Action:_restrict_TIMER(Handle:timer, any:client)
{
	if ((client = GetClientOfUserId(client)) > 0 && HaveAccessToMenu(client))
	{
		if (g_Action[client] == wl_Restrict) wS_ShowRestrictMenu(client);
		else if (g_Action[client] == wl_UnRestrict) wS_ShowUnRestrictMenu(client);
		else wS_ShowAdminMenu(client);
	}
	return Plugin_Stop;
}

stock RestrictFromChat(client, limit)
{
	decl String:weapon_[WEAPON_LENGTH];
	GetArrayString(g_Items_Arrr, WeaponIndexInAr[client], weapon_, WEAPON_LENGTH);
	FakeClientCommand(client, "wl_restrict %s %d", weapon_, limit);
}