public Action:wl_restrict(client, x)
{
	if (x != 2)
	{
		ReplyToCommand(client, "wl_restrict <weapon> <amount per team>");
		return Plugin_Handled;
	}

	decl String:weapon_1[WEAPON_LENGTH], slot;
	GetCmdArg(1, weapon_1, WEAPON_LENGTH);
	
	if (!xTrimString(weapon_1) || !GetTrieValue(g_Slots_Trie, weapon_1, slot))
	{
		ReplyToCommand(client, "wl_restrict <weapon> <amount per team>");
		return Plugin_Handled;
	}
	
	decl String:sNum[8];
	GetCmdArg(2, sNum, sizeof(sNum));
	
	new limit = StringToInt(sNum);
	if (limit < 0) limit = 0;
	else if (limit > MaxClients) limit = MaxClients;
	
	if (GetTrieValue(g_Limit_Trie, weapon_1, x) && x == limit)
		return Plugin_Handled;
	
	SetTrieValue(g_Limit_Trie, weapon_1, limit, true);
	decl String:weapon_2[WEAPON_LENGTH];
	
	if (wS_GetSimilarWeapon(weapon_1, weapon_2, WEAPON_LENGTH))
	{
		SetTrieValue(g_Limit_Trie, weapon_2, limit, true);
		decl String:weapons_[WEAPON_LENGTH * 2];
		FormatEx(weapons_, sizeof(weapons_), "%s + %s", weapon_1, weapon_2);
		NotityRestricted(0, weapons_, limit);
		ReplyToCommand(client, "%s restricted %d per team", weapons_, limit);
	}
	else
	{
		NotityRestricted(0, weapon_1, limit);
		ReplyToCommand(client, "%s restricted %d per team", weapon_1, limit);
	}
	
	// Если у игрока m4a1_silencer (csgo), то GetEntityClassname выдаст m4a1.
	// Поэтому меняем имя с m4a1_silencer на m4a1.
	wS_GetMainWeaponName(weapon_1, weapon_1, WEAPON_LENGTH);
	
	if (!wl_pause && wl_remove_after_restrict)
	{
		wS_CheckWeaponLimitInTeam(weapon_1, slot, 2, limit);
		wS_CheckWeaponLimitInTeam(weapon_1, slot, 3, limit);
	}
	
	Call_StartForward(Handle:g_hEvent[WL_OnWeaponLimited]);
	Call_PushString(weapon_1);
	Call_PushCell(limit);
	Call_Finish();

	return Plugin_Handled;
}

static wS_CheckWeaponLimitInTeam(const String:weapon_[], slot, team, limit)
{
	// Сначала проверяем игроков с иммунитетом, затем остальных, чтобы ограничение правильно сработало.
	
	new Handle:hAr1 = CreateArray(1); // игроки с иммунитетом
	new Handle:hAr2 = CreateArray(1); // обычные
	
	decl client,  weapon;
	new weapon_count = 0;
	
	for (client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client) && GetClientTeam(client) == team && IsPlayerAlive(client))
		{
			if (Immunity(client))
			{
				if (wl_immunity_counter)
					PushArrayCell(hAr1, client);
			}
			else
				PushArrayCell(hAr2, client);
		}
	}
	
	new index = GetArraySize(hAr1);
	while (--index > -1)
	{
		if (wS_GetWeaponIndex(GetArrayCell(hAr1, index), weapon_, slot) > MaxClients && ++weapon_count >= limit)
			break;
	}
	CloseHandle(hAr1);
	
	index = GetArraySize(hAr2);
	while (--index > -1)
	{
		client = GetArrayCell(hAr2, index);
		if ((weapon = wS_GetWeaponIndex(client, weapon_, slot)) > MaxClients && ++weapon_count > limit)
			RemoveOrDrop(client, weapon);
	}
	CloseHandle(hAr2);
}