stock bool:xTrimString(String:s[])
{
	new i = TrimString(s);
	if (i < 1) return false;
	while (--i > -1) s[i] = CharToLower(s[i]);
	return true;
}

stock bool:Immunity(client)
{
	if (wl_immunity_flag)
	{
		new flags = GetUserFlagBits(client);
		if (flags & wl_immunity_flag || flags & ADMFLAG_ROOT)
			return true;
	}
	return false;
}

stock wS_DropAllWeapons()
{
	decl weapon, slot;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsPlayerAlive(i) && !Immunity(i))
		{
			for (slot = 0; slot <= 30; slot++)
			{
				if ((weapon = GetEntPropEnt(i, Prop_Send, "m_hMyWeapons", slot)) <= MaxClients) break;
				CS_DropWeapon(i, weapon, false, false);
			}
		}
	}
}

stock RemoveOrDrop(client, weapon)
{
	ClientCommand(client, "lastinv");
	if (wl_remove)
	{
		RemovePlayerItem (client, weapon);
		AcceptEntityInput(weapon, "Kill");
	}
	else {
		CS_DropWeapon(client, weapon, false, false);
	}
}

stock NotityRestricted(client, const String:weapon_[], limit)
{
	if (wl_notify)
	{
		if (client > 0) PrintToChat(client, "%t", "restricted", weapon_, limit);
		else PrintToChatAll("%t", "restricted", weapon_, limit);
	}
}

stock wS_GetSoundFromCvar(Handle:hCvar, String:sound[], size)
{
	decl index;
	GetConVarString(hCvar, sound, size);
	if (TrimString(sound) > 4 && (index = FindCharInString(sound, '.', true)) > 0 && (!strcmp(sound[index + 1], "mp3", false) || !strcmp(sound[index + 1], "wav", false)))
	{
		ReplaceString(sound, size, "\\", "/");

		if (StrContains(sound, "sound/", false) != 0) Format(sound, size, "sound/%s", sound);
		AddFileToDownloadsTable(sound);

		if (g_bCSGO)
		{
			Format(sound, size, "*%s", sound[6]);
			static x = INVALID_STRING_TABLE;
			if (x != INVALID_STRING_TABLE || (x = FindStringTable("soundprecache")) != INVALID_STRING_TABLE)
				AddToStringTable(x, sound);
			else
			{
				sound[0] = 0;
				LogError("FindStringTable soundprecache error");
			}
		}
		else
		{
			strcopy(sound, size, sound[6]);
			PrecacheSound(sound);
		}
	}
	else
		sound[0] = 0;
}

stock wS_GetWeaponIndex(client, const String:weapon_[], slot)
{
	static String:w[WEAPON_LENGTH], weapon;
	if ((weapon = GetPlayerWeaponSlot(client, slot)) > MaxClients && GetEntityClassname(weapon, w, WEAPON_LENGTH))
	{
		if (!strcmp(weapon_, w[7], false))
			return weapon;
		
		// 0 - автомат, дробовик, винтовка
		// 1 - пистолет
		// 2 - нож / taser
		// 3 - граната
		// 4 - бомба c4
		
		if ((slot == 2 && g_bCSGO) || slot == 3)
		{
			for (slot = 0; slot <= 30; slot++)
			{
				// Возвращает -1, если оружия нет.
				// То, которое есть - всегда вверху, так что если встретили -1, можно прервать цикл.
				// m_hMyWeapons выдаёт только оружие, здесь нет набора сапера, брони и тд.
				
				if ((weapon = GetEntPropEnt(client, Prop_Send, "m_hMyWeapons", slot)) <= MaxClients)
					return -1;

				if (GetEntityClassname(weapon, w, WEAPON_LENGTH) && !strcmp(weapon_, w[7], false))
					return weapon;
			}
		}
	}
	return -1;	
}

stock bool:wS_GetSimilarWeapon(const String:w1[], String:w2[], x)
{
	w2[0] = 0;
	if (!g_bCSGO) return false;
	if 		(!strcmp(w1, "mp7"))			return strcopy(w2, x, "mp5sd")			> 0;
	else if (!strcmp(w1, "mp5sd"))			return strcopy(w2, x, "mp7")			> 0;
	else if (!strcmp(w1, "m4a1"))			return strcopy(w2, x, "m4a1_silencer")	> 0;
	else if (!strcmp(w1, "m4a1_silencer"))	return strcopy(w2, x, "m4a1")			> 0;
	else if (!strcmp(w1, "hkp2000"))		return strcopy(w2, x, "usp_silencer")	> 0;
	else if (!strcmp(w1, "usp_silencer"))	return strcopy(w2, x, "hkp2000")		> 0;
	else if (!strcmp(w1, "p250"))			return strcopy(w2, x, "cz75a")			> 0;
	else if (!strcmp(w1, "cz75a"))			return strcopy(w2, x, "p250")			> 0;
	else if (!strcmp(w1, "deagle"))			return strcopy(w2, x, "revolver")		> 0;
	else if (!strcmp(w1, "revolver"))		return strcopy(w2, x, "deagle")			> 0;
	return false;
}

stock wS_GetMainWeaponName(const String:w1[], String:w2[], x)
{
	if (!g_bCSGO) return;
	if 		(!strcmp(w1, "mp5sd"))			strcopy(w2, x, "mp7");
	else if (!strcmp(w1, "m4a1_silencer"))	strcopy(w2, x, "m4a1");
	else if (!strcmp(w1, "usp_silencer"))	strcopy(w2, x, "hkp2000");
	else if (!strcmp(w1, "cz75a"))			strcopy(w2, x, "p250");
	else if (!strcmp(w1, "revolver"))		strcopy(w2, x, "deagle");
}

#define p PushArrayString

stock Handle:GetWeaponListAr()
{
	new Handle:a = CreateArray(WEAPON_LENGTH);

	p(a, "awp_0");
	p(a, "ak47_0");
	p(a, "m4a1_0");
	p(a, "aug_0");
	p(a, "famas_0");
	p(a, "g3sg1_0");
	p(a, "m249_0");
	p(a, "mac10_0");
	p(a, "p90_0");
	p(a, "ump45_0");
	p(a, "xm1014_0");
	
	if (g_bCSGO)
	{
		p(a, "galilar_0");
		p(a, "bizon_0");
		p(a, "m4a1_silencer_0");
		p(a, "mag7_0");
		p(a, "mp5sd_0");
		p(a, "mp7_0");
		p(a, "mp9_0");
		p(a, "negev_0");
		p(a, "nova_0");
		p(a, "sawedoff_0");
		p(a, "scar20_0");
		p(a, "sg556_0");
		p(a, "ssg08_0");
	}
	else
	{
		p(a, "galil_0");
		p(a, "m3_0");
		p(a, "mp5navy_0");
		p(a, "scout_0");
		p(a, "sg550_0");
		p(a, "sg552_0");
		p(a, "tmp_0");
	}
	
	//
	p(a, NEW_LINE_SYMBOL);
	//
	
	p(a, "deagle_1");
	p(a, "elite_1");
	p(a, "fiveseven_1");
	p(a, "glock_1");
	
	if (g_bCSGO)
	{
		p(a, "hkp2000_1");
		p(a, "tec9_1");
		p(a, "usp_silencer_1");
		p(a, "cz75a_1");
		p(a, "revolver_1");
		p(a, "p250_1");
	}
	else
	{
		p(a, "usp_1");
		p(a, "p228_1");
	}
	
	//
	p(a, NEW_LINE_SYMBOL);
	//
	
	p(a, "flashbang_3");
	p(a, "hegrenade_3");
	p(a, "smokegrenade_3");
	
	if (g_bCSGO)
	{
		p(a, "molotov_3");
		p(a, "incgrenade_3");
		p(a, "decoy_3");
		p(a, "tagrenade_3");
	}
	
	//
	p(a, NEW_LINE_SYMBOL);
	//
	
	p(a, "knife_2");
	
	if (g_bCSGO)
	{
		p(a, "taser_2");
		p(a, NEW_LINE_SYMBOL);
	}
	
	p(a, "c4_4");
	
	return a;
}