stock ServerVars()
{
	new Handle:hCvar = CreateConVar("wl_immunity_flag", "z", "Immunity to restrict weapons");
	wl_flag(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_immunity_counter", "1");
	wl_immunity_counter = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_remove", "0", "If player has picked up restricted weapon: 1 = remove, 0 = drop");
	wl_remove = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_remove_after_restrict", "0", "Check limit after wl_restrict/wl_restrict_all (1 = on, 0 = off)");
	wl_remove_after_restrict = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_notify", "1", "Chat notifications (1 = on, 0 = off)");
	wl_notify = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_map_end_unrestrcit", "1", "Unrestrict all weapons if map ended (1 = on, 0 = off)");
	wl_map_end_unrestrcit = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("wl_pause", "0", "1 = Temporarily allows the use of all weapons\n0 = Restrict again works");
	wl_pause = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar_wl_sound = CreateConVar("wl_sound", "resource/warning.wav", "Sound when trying to use restricted weapon (\"\" = off)");
	AutoExecConfig(true, "weapon_limit", "weapon_limit");
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	decl String:CvarName[32];
	GetConVarName(hCvar, CvarName, sizeof(CvarName));
	if (	 !strcmp(CvarName[3], "immunity_flag"			, false)) wl_flag(hCvar, NewValue);
	else if (!strcmp(CvarName[3], "immunity_counter"		, false)) wl_immunity_counter		= bool:StringToInt(NewValue);
	else if (!strcmp(CvarName[3], "remove"					, false)) wl_remove					= bool:StringToInt(NewValue);
	else if (!strcmp(CvarName[3], "remove_after_restrict"	, false)) wl_remove_after_restrict	= bool:StringToInt(NewValue);
	else if (!strcmp(CvarName[3], "notify"					, false)) wl_notify					= bool:StringToInt(NewValue);
	else if (!strcmp(CvarName[3], "map_end_unrestrcit"		, false)) wl_map_end_unrestrcit		= bool:StringToInt(NewValue);
	else if (!strcmp(CvarName[3], "pause"					, false))
	{
		if (!(wl_pause = StringToInt(NewValue) == 1) && GetTrieSize(g_Limit_Trie)) {
			wS_DropAllWeapons();
		}
	}
}
	
static wl_flag(Handle:hCvar = INVALID_HANDLE, const String:sFlag[] = "")
{
	decl bool:bNeedDrop;
	
	if (wl_immunity_flag)
	{
		wl_immunity_flag = 0;
		bNeedDrop = true;
	}
	else
		bNeedDrop = false;
	
	decl String:s[12];
	if (sFlag[0]) strcopy(s, sizeof(s), sFlag);
	else if (hCvar) GetConVarString(hCvar, s, sizeof(s));
	else return; // wtf
	
	if (xTrimString(s))
	{
		decl AdminFlag:flag;
		if (FindFlagByChar(s[0], flag))
		{
			wl_immunity_flag = FlagToBit(flag);
			bNeedDrop = true;
		}
	}
	
	if (bNeedDrop && GetTrieSize(g_Limit_Trie))
		wS_DropAllWeapons();
}

public OnConfigsExecuted()
{
	wS_GetSoundFromCvar(hCvar_wl_sound, wl_sound, sizeof(wl_sound));
}